/*-
 * Copyright (c) 2000-2001
 * Tatsuya Kudoh(CDR/TK),ROYALPANDA.    All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include<stdlib.h>
#include<sys/bios.h>

#include"pietable.h"
#include"keycode.h"

#pragma noregalo


/***********************
*
* main pie
*
************************


/* 2nd pies */

/*
** control code
*/

static pieent_t Menu_hira_ctrl[9] = {
    {"Ji",KEYSTR_KATAKANA}, {"p",KEYSTR_ASCII},   {NULL,NULL},
    {"",KEYSTR_BACKSPACE},{"^u",KEYSTR_TAB},     {"",KEYSTR_SPACE},
    {"s",KEYSTR_HOME},     {"s",KEYSTR_RETURN},  {"s",KEYSTR_END},
};

static pieent_t Menu_kata_ctrl[9] = {
    {NULL,NULL},              {"p",KEYSTR_ASCII},   {"",KEYSTR_HIRAGANA},
    {"",KEYSTR_BACKSPACE},{"^u",KEYSTR_TAB},     {"",KEYSTR_SPACE},
    {"s",KEYSTR_HOME},     {"s",KEYSTR_RETURN},  {"s",KEYSTR_END},
};

static pieent_t Menu_asc_ctrl[9] = {
    {"Ji",KEYSTR_KATAKANA}, {NULL,NULL},             {"",KEYSTR_HIRAGANA},
    {"",KEYSTR_BACKSPACE},{"^u",KEYSTR_TAB},     {"",KEYSTR_SPACE},
    {"s",KEYSTR_HOME},     {"s",KEYSTR_RETURN},  {"s",KEYSTR_END},
};



/*
** hiragana/normal
*/

static pieent_t Menu_hira_k[9] = {
	{""	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
};

static pieent_t Menu_hira_a[9] = {
	{"["	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{"B"	,NULL},	{""	,NULL},	{"A"	,NULL},
};

static pieent_t Menu_hira_y[9] = {
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{NULL	,NULL},	{""	,NULL},	{"E"	,NULL},
};
static pieent_t Menu_hira_s[9] = {
	{""	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
};

static pieent_t Menu_hira_m[9] = {
	{"݂"	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{"݂"	,NULL},	{""	,NULL},	{"݂"	,NULL},
};

static pieent_t Menu_hira_t[9] = {
	{""	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
};

static pieent_t Menu_hira_n[9] = {
	{"ɂ"	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{"ɂ"	,NULL},	{""	,NULL},	{"ɂ"	,NULL},
};

static pieent_t Menu_hira_h[9] = {
	{"Ђ"	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{"Ђ"	,NULL},	{""	,NULL},	{"Ђ"	,NULL},
};


/*
** hiragana/shifted
*/

static pieent_t Menu_hira_g[9] = {
	{""	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
};

static pieent_t Menu_hira_r[9] = {
	{""	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
};

static pieent_t Menu_hira_x[9] = {
	{"u"	,NULL},	{""	,NULL},	{"v"	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{NULL	,NULL},	{""	,NULL},	{NULL	,NULL},
};

static pieent_t Menu_hira_z[9] = {
	{""	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
};

static pieent_t Menu_hira_d[9] = {
	{""	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
};

static pieent_t Menu_hira_b[9] = {
	{"т"	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{"т"	,NULL},	{""	,NULL},	{"т"	,NULL},
};

static pieent_t Menu_hira_p[9] = {
	{"҂"	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{"҂"	,NULL},	{""	,NULL},	{"҂"	,NULL},
};


/*
** katakana/normal
*/

static pieent_t Menu_kata_k[9] = {
	{"L"	,NULL},	{"L"	,NULL},	{NULL	,NULL},
	{"N"	,NULL},	{"J"	,NULL},	{"R"	,NULL},
	{"L"	,NULL},	{"P"	,NULL},	{"L"	,NULL},
};

static pieent_t Menu_kata_a[9] = {
	{"["	,NULL},	{"C"	,NULL},	{NULL	,NULL},
	{"E"	,NULL},	{"A"	,NULL},	{"I"	,NULL},
	{"A"	,NULL},	{"G"	,NULL},	{"B"	,NULL},
};

static pieent_t Menu_kata_y[9] = {
	{""	,NULL},	{""	,NULL},	{"b"	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{NULL	,NULL},	{""	,NULL},	{"E"	,NULL},
};
static pieent_t Menu_kata_s[9] = {
	{"V"	,NULL},	{"V"	,NULL},	{NULL	,NULL},
	{"X"	,NULL},	{"T"	,NULL},	{"\"	,NULL},
	{"V"	,NULL},	{"Z"	,NULL},	{"V"	,NULL},
};

static pieent_t Menu_kata_m[9] = {
	{"~"	,NULL},	{"~"	,NULL},	{NULL	,NULL},
	{""	,NULL},	{"}"	,NULL},	{""	,NULL},
	{"~"	,NULL},	{""	,NULL},	{"~"	,NULL},
};

static pieent_t Menu_kata_t[9] = {
	{"`"	,NULL},	{"`"	,NULL},	{NULL	,NULL},
	{"c"	,NULL},	{"^"	,NULL},	{"g"	,NULL},
	{"`"	,NULL},	{"e"	,NULL},	{"`"	,NULL},
};

static pieent_t Menu_kata_n[9] = {
	{"j"	,NULL},	{"j"	,NULL},	{NULL	,NULL},
	{"k"	,NULL},	{"i"	,NULL},	{"m"	,NULL},
	{"j"	,NULL},	{"l"	,NULL},	{"j"	,NULL},
};

static pieent_t Menu_kata_h[9] = {
	{"q"	,NULL},	{"q"	,NULL},	{NULL	,NULL},
	{"t"	,NULL},	{"n"	,NULL},	{"z"	,NULL},
	{"q"	,NULL},	{"w"	,NULL},	{"q"	,NULL},
};


/*
** katakana/shifted
*/

static pieent_t Menu_kata_g[9] = {
	{"M"	,NULL},	{"M"	,NULL},	{NULL	,NULL},
	{"O"	,NULL},	{"K"	,NULL},	{"S"	,NULL},
	{"M"	,NULL},	{"Q"	,NULL},	{"M"	,NULL},
};

static pieent_t Menu_kata_r[9] = {
	{""	,NULL},	{""	,NULL},	{NULL	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
	{""	,NULL},	{""	,NULL},	{""	,NULL},
};

static pieent_t Menu_kata_x[9] = {
	{"u"	,NULL},	{"B"	,NULL},	{"v"	,NULL},
	{"D"	,NULL},	{"@"	,NULL},	{"H"	,NULL},
	{NULL	,NULL},	{"F"	,NULL},	{NULL	,NULL},
};

static pieent_t Menu_kata_z[9] = {
	{"W"	,NULL},	{"W"	,NULL},	{NULL	,NULL},
	{"Y"	,NULL},	{"U"	,NULL},	{"]"	,NULL},
	{"W"	,NULL},	{"["	,NULL},	{"W"	,NULL},
};

static pieent_t Menu_kata_d[9] = {
	{"a"	,NULL},	{"a"	,NULL},	{NULL	,NULL},
	{"d"	,NULL},	{"_"	,NULL},	{"h"	,NULL},
	{"a"	,NULL},	{"f"	,NULL},	{"a"	,NULL},
};

static pieent_t Menu_kata_b[9] = {
	{"r"	,NULL},	{"r"	,NULL},	{NULL	,NULL},
	{"u"	,NULL},	{"o"	,NULL},	{"{"	,NULL},
	{"r"	,NULL},	{"x"	,NULL},	{"r"	,NULL},
};

static pieent_t Menu_kata_p[9] = {
	{"s"	,NULL},	{"s"	,NULL},	{NULL	,NULL},
	{"v"	,NULL},	{"p"	,NULL},	{"|"	,NULL},
	{"s"	,NULL},	{"y"	,NULL},	{"s"	,NULL},
};


/*
** ascii/normal
*/

static pieent_t Menu_asc_a[9] = {
	{NULL	,NULL},	{"b"	,NULL},	{NULL	,NULL},
	{"c"	,NULL},	{"a"	,NULL},	{"e"	,NULL},
	{NULL	,NULL},	{"d"	,NULL},	{NULL	,NULL},
};

static pieent_t Menu_asc_6[9] = {
	{"-"	,NULL},	{"7"	,NULL},	{NULL	,NULL},
	{"8"	,NULL},	{"6"	,NULL},	{"0"	,NULL},
	{"="	,NULL},	{"9"	,NULL},	{"\\"	,NULL},
};

static pieent_t Menu_asc_f[9] = {
	{","	,NULL},	{"g"	,NULL},	{NULL	,NULL},
	{"h"	,NULL},	{"f"	,NULL},	{"j"	,NULL},
	{"."	,NULL},	{"i"	,NULL},	{";"	,NULL},
};

static pieent_t Menu_asc_1[9] = {
	{"["	,NULL},	{"2"	,NULL},	{"]"	,NULL},
	{"3"	,NULL},	{"1"	,NULL},	{"5"	,NULL},
	{NULL	,NULL},	{"4"	,NULL},	{NULL	,NULL},
};

static pieent_t Menu_asc_k[9] = {
	{NULL	,NULL},	{"l"	,NULL},	{NULL	,NULL},
	{"m"	,NULL},	{"k"	,NULL},	{"o"	,NULL},
	{NULL	,NULL},	{"n"	,NULL},	{NULL	,NULL},
};

static pieent_t Menu_asc_p[9] = {
	{"'"	,NULL},	{"q"	,NULL},	{NULL	,NULL},
	{"r"	,NULL},	{"p"	,NULL},	{"t"	,NULL},
	{"`"	,NULL},	{"s"	,NULL},	{"/"	,NULL},
};

static pieent_t Menu_asc_u[9] = {
	{NULL	,NULL},	{"v"	,NULL},	{NULL	,NULL},
	{"w"	,NULL},	{"u"	,NULL},	{"z"	,NULL},
	{"x"	,NULL},	{"y"	,NULL},	{NULL	,NULL},
};


/*
** ascii/shifted
*/

static pieent_t Menu_asc_A[9] = {
	{NULL	,NULL},	{"B"	,NULL},	{NULL	,NULL},
	{"C"	,NULL},	{"A"	,NULL},	{"E"	,NULL},
	{NULL	,NULL},	{"D"	,NULL},	{NULL	,NULL},
};

static pieent_t Menu_asc_6s[9] = {
	{"_"	,NULL},	{"&"	,NULL},	{NULL	,NULL},
	{"*"	,NULL},	{"^"	,NULL},	{")"	,NULL},
	{"+"	,NULL},	{"("	,NULL},	{"|"	,NULL},
};

static pieent_t Menu_asc_F[9] = {
	{"<"	,NULL},	{"G"	,NULL},	{NULL	,NULL},
	{"H"	,NULL},	{"F"	,NULL},	{"J"	,NULL},
	{">"	,NULL},	{"I"	,NULL},	{":"	,NULL},
};

static pieent_t Menu_asc_1s[9] = {
	{"{"	,NULL},	{"@"	,NULL},	{"}"	,NULL},
	{"#"	,NULL},	{"!"	,NULL},	{"%"	,NULL},
	{NULL	,NULL},	{"$"	,NULL},	{NULL	,NULL},
};

static pieent_t Menu_asc_K[9] = {
	{NULL	,NULL},	{"L"	,NULL},	{NULL	,NULL},
	{"M"	,NULL},	{"K"	,NULL},	{"O"	,NULL},
	{NULL	,NULL},	{"N"	,NULL},	{NULL	,NULL},
};

static pieent_t Menu_asc_P[9] = {
	{"\""	,NULL},	{"Q"	,NULL},	{NULL	,NULL},
	{"R"	,NULL},	{"P"	,NULL},	{"T"	,NULL},
	{"~"	,NULL},	{"S"	,NULL},	{"?"	,NULL},
};

static pieent_t Menu_asc_U[9] = {
	{NULL	,NULL},	{"V"	,NULL},	{NULL	,NULL},
	{"W"	,NULL},	{"U"	,NULL},	{"Z"	,NULL},
	{"X"	,NULL},	{"Y"	,NULL},	{NULL	,NULL},
};


/*
** 1st pies
*/

static pieent_t Menu_hira_0[9] = {
	{"",Menu_hira_k},	{"",Menu_hira_a},	{"",Menu_hira_y},
	{"",Menu_hira_s},	{NULL	,NULL},		{"",Menu_hira_ctrl},
	{"",Menu_hira_t},	{"",Menu_hira_n},	{"",Menu_hira_h},
};

static pieent_t Menu_hira_1[9] = {
	{"",Menu_hira_g},	{"",Menu_hira_r},	{"",Menu_hira_x},
	{"",Menu_hira_z},	{NULL,NULL},		{"",Menu_hira_m},
	{"",Menu_hira_d},	{"",Menu_hira_p},	{"",Menu_hira_b},
};

static pieent_t Menu_kata_0[9] = {
	{"J",Menu_kata_k},	{"A",Menu_kata_a},	{"",Menu_kata_y},
	{"T",Menu_kata_s},	{NULL	,NULL},		{"",Menu_kata_ctrl},
	{"^",Menu_kata_t},	{"i",Menu_kata_n},	{"n",Menu_kata_h},
};

static pieent_t Menu_kata_1[9] = {
	{"K",Menu_kata_g},	{"",Menu_kata_r},	{"@",Menu_kata_x},
	{"U",Menu_kata_z},	{NULL,NULL},		{"}",Menu_kata_m},
	{"_",Menu_kata_d},	{"p",Menu_kata_p},	{"o",Menu_kata_b},
};


static pieent_t Menu_ascii_0[9] = {
	{"a",Menu_asc_a},	{"6",Menu_asc_6},	{"1",Menu_asc_1},
	{"f",Menu_asc_f},	{NULL	,NULL},		{"",Menu_asc_ctrl},
	{"k",Menu_asc_k},	{"p",Menu_asc_p},	{"u",Menu_asc_u},
};


static pieent_t Menu_ascii_1[9] = {
	{"A",Menu_asc_A},	{"^",Menu_asc_6s},	{"!",Menu_asc_1s},
	{"F",Menu_asc_F},	{NULL	,NULL},		{"",Menu_asc_ctrl},
	{"K",Menu_asc_K},	{"P",Menu_asc_P},	{"U",Menu_asc_U},
};

/*
** Pies
*/

pieent_t *PieTable[3][2] = {
	{ Menu_hira_0, Menu_hira_1,},
	{ Menu_kata_0, Menu_kata_1,},
	{ Menu_ascii_0, Menu_ascii_1,},
};

